diff --git a/test/unit/qmd_installer_test.rb b/test/unit/qmd_installer_test.rb
new file mode 100644
index 00000000..149ad449
--- /dev/null
+++ b/test/unit/qmd_installer_test.rb
@@ -0,0 +1,103 @@
+# frozen_string_literal: true
+
+require "test_helper"
+require "hive/qmd_installer"
+
+class QmdInstallerTest < Minitest::Test
+  include HiveTestHelper
+
+  def test_skips_when_install_qmd_disabled
+    with_env("HIVE_INSTALL_QMD" => "0") do
+      result = Hive::QmdInstaller.new(
+        data_home: Dir.mktmpdir,
+        bin_home: Dir.mktmpdir,
+        which: ->(_) { nil }
+      ).install!
+      assert_equal :skipped, result.status
+      assert_match(/skipped/, result.message)
+    end
+  end
+
+  def test_skips_when_npm_missing
+    Dir.mktmpdir do |data|
+      Dir.mktmpdir do |bin|
+        result = Hive::QmdInstaller.new(
+          data_home: data,
+          bin_home: bin,
+          which: ->(name) { name == "npm" ? nil : nil },
+          runner: ->(*) { flunk "runner must not be called without npm" }
+        ).install!
+        assert_equal :skipped, result.status
+        assert_match(/npm not on PATH/, result.message)
+      end
+    end
+  end
+
+  def test_installs_and_links_qmd
+    Dir.mktmpdir do |data|
+      Dir.mktmpdir do |bin|
+        qmd_bin = File.join(data, "qmd", "bin", "qmd")
+        runner = lambda { |_env, argv, chdir:|
+          if argv.include?("install")
+            FileUtils.mkdir_p(File.dirname(qmd_bin))
+            File.write(qmd_bin, "#!/bin/sh\necho 1.0.0\n")
+            FileUtils.chmod(0o755, qmd_bin)
+            [ true, "ok" ]
+          elsif argv.include?("--version")
+            [ true, "1.0.0" ]
+          else
+            [ true, "ok" ]
+          end
+        }
+        which = lambda { |name|
+          name == "npm" ? "/usr/bin/npm" : nil
+        }
+        result = Hive::QmdInstaller.new(
+          data_home: data,
+          bin_home: bin,
+          runner: runner,
+          which: which
+        ).install!
+        assert_equal :installed, result.status
+        assert File.symlink?(File.join(bin, "qmd")) || File.exist?(File.join(bin, "qmd"))
+      end
+    end
+  end
+
+  def test_failed_npm_install_returns_failed
+    Dir.mktmpdir do |data|
+      Dir.mktmpdir do |bin|
+        runner = lambda { |_env, argv, chdir:|
+          return [ false, "network error" ] if argv.include?("install")
+
+          [ true, "" ]
+        }
+        result = Hive::QmdInstaller.new(
+          data_home: data,
+          bin_home: bin,
+          runner: runner,
+          which: ->(n) { n == "npm" ? "/usr/bin/npm" : nil }
+        ).install!
+        assert_equal :failed, result.status
+        assert_match(/install failed/, result.message)
+      end
+    end
+  end
+
+  def test_uses_hive_qmd_bin_when_set
+    Dir.mktmpdir do |dir|
+      qmd = File.join(dir, "qmd")
+      File.write(qmd, "#!/bin/sh\necho ok\n")
+      FileUtils.chmod(0o755, qmd)
+      with_env("HIVE_QMD_BIN" => qmd) do
+        result = Hive::QmdInstaller.new(
+          data_home: dir,
+          bin_home: dir,
+          runner: ->(*) { flunk "should not npm install" }
+        ).install!
+        assert_equal :unchanged, result.status
+        assert_equal qmd, result.qmd_bin
+      end
+    end
+  end
+end
diff --git a/test/unit/web/app_provisioner_test.rb b/test/unit/web/app_provisioner_test.rb
new file mode 100644
index 00000000..0cb23597
--- /dev/null
+++ b/test/unit/web/app_provisioner_test.rb
@@ -0,0 +1,124 @@
+# frozen_string_literal: true
+
+require "test_helper"
+require "hive/web/app_provisioner"
+
+class AppProvisionerTest < Minitest::Test
+  include HiveTestHelper
+
+  def setup_source_app
+    dir = Dir.mktmpdir("hive-web-src")
+    FileUtils.mkdir_p(File.join(dir, "config"))
+    FileUtils.mkdir_p(File.join(dir, "bin"))
+    FileUtils.mkdir_p(File.join(dir, "app"))
+    FileUtils.mkdir_p(File.join(dir, "test"))
+    File.write(File.join(dir, "config", "application.rb"), "# rails app marker\n")
+    File.write(File.join(dir, "Gemfile"), "source 'https://rubygems.org'\n")
+    File.write(File.join(dir, "Gemfile.lock"), "PATH\n  remote: ..\n")
+    File.write(File.join(dir, "bin", "rails"), "#!/usr/bin/env bash\nexit 0\n")
+    FileUtils.chmod(0o755, File.join(dir, "bin", "rails"))
+    File.write(File.join(dir, "test", "example_test.rb"), "# should not be copied\n")
+    dir
+  end
+
+  def test_provisioner_creates_versioned_webapp_with_app_files
+    source = setup_source_app
+    Dir.mktmpdir("hive-data") do |data|
+      runner = lambda { |_env, _argv, chdir:| [ true, "ok" ] }
+      provisioner = Hive::Web::AppProvisioner.new(
+        data_home: data,
+        version: "9.9.9",
+        source_dir: source,
+        runner: runner
+      )
+      dir = provisioner.ensure_provisioned!
+
+      assert_equal File.join(data, "webapp", "9.9.9", "web"), dir
+      assert File.file?(File.join(dir, "config", "application.rb"))
+      assert File.file?(File.join(dir, Hive::Web::AppProvisioner::MARKER))
+      refute File.exist?(File.join(dir, "test")), "test/ must not be copied into the runtime"
+      refute File.exist?(File.join(dir, "Gemfile.lock")),
+             "checkout Gemfile.lock (path source) must be dropped for provisioned layout"
+    end
+  ensure
+    FileUtils.rm_rf(source) if source
+  end
+
+  def test_provisioner_rerun_is_noop_when_up_to_date
+    source = setup_source_app
+    Dir.mktmpdir("hive-data") do |data|
+      calls = 0
+      runner = lambda { |_env, _argv, chdir:|
+        calls += 1
+        [ true, "ok" ]
+      }
+      provisioner = Hive::Web::AppProvisioner.new(
+        data_home: data,
+        version: "9.9.9",
+        source_dir: source,
+        runner: runner
+      )
+      first = provisioner.ensure_provisioned!
+      second = provisioner.ensure_provisioned!
+
+      assert_equal first, second
+      # First provision: bundle config + bundle install + assets:precompile.
+      assert_equal 3, calls, "first provision runs config+bundle+assets; re-run must not invoke runner"
+    end
+  ensure
+    FileUtils.rm_rf(source) if source
+  end
+
+  def test_bundle_install_failure_raises_typed_error_with_repair_command
+    source = setup_source_app
+    Dir.mktmpdir("hive-data") do |data|
+      runner = lambda { |_env, argv, chdir:|
+        if argv.first == "bundle"
+          [ false, "Could not find gem" ]
+        else
+          [ true, "ok" ]
+        end
+      }
+      provisioner = Hive::Web::AppProvisioner.new(
+        data_home: data,
+        version: "9.9.9",
+        source_dir: source,
+        runner: runner
+      )
+      error = assert_raises(Hive::Web::AppProvisioner::Error) do
+        provisioner.ensure_provisioned!
+      end
+      assert_match(/bundle install failed/, error.message)
+      assert_match(/bundle install/, error.message)
+    end
+  ensure
+    FileUtils.rm_rf(source) if source
+  end
+
+  def test_missing_source_raises_guidance
+    Dir.mktmpdir("hive-data") do |data|
+      provisioner = Hive::Web::AppProvisioner.new(
+        data_home: data,
+        version: "9.9.9",
+        source_dir: File.join(data, "nope"),
+        runner: ->(*) { [ true, "" ] }
+      )
+      error = assert_raises(Hive::Web::AppProvisioner::Error) do
+        provisioner.ensure_provisioned!
+      end
+      assert_match(/shipped Rails app source not found/, error.message)
+      assert_match(/hive setup/, error.message)
+    end
+  end
+
+  def test_provisioned_predicate
+    Dir.mktmpdir("hive-data") do |data|
+      refute Hive::Web::AppProvisioner.provisioned?(data_home: data, version: "1.0.0")
+      dir = Hive::Web::AppProvisioner.provisioned_app_dir(data_home: data, version: "1.0.0")
+      FileUtils.mkdir_p(File.join(dir, "config"))
+      File.write(File.join(dir, "config", "application.rb"), "# app\n")
+      File.write(File.join(dir, Hive::Web::AppProvisioner::MARKER), "version=1.0.0\n")
+      assert Hive::Web::AppProvisioner.provisioned?(data_home: data, version: "1.0.0")
+    end
+  end
+end
diff --git a/test/unit/web/auth_mode_test.rb b/test/unit/web/auth_mode_test.rb
new file mode 100644
index 00000000..a632c555
--- /dev/null
+++ b/test/unit/web/auth_mode_test.rb
@@ -0,0 +1,76 @@
+# frozen_string_literal: true
+
+require "test_helper"
+require "hive/web/auth_mode"
+
+class AuthModeTest < Minitest::Test
+  def test_loopback_default_is_none
+    mode = Hive::Web::AuthMode.resolve(
+      bind: "127.0.0.1",
+      config: { "auth" => nil, "github" => { "owner" => nil } }
+    )
+    assert_equal "none", mode
+  end
+
+  def test_localhost_is_loopback
+    mode = Hive::Web::AuthMode.resolve(
+      bind: "localhost",
+      config: { "auth" => nil, "github" => {} }
+    )
+    assert_equal "none", mode
+  end
+
+  def test_explicit_github_on_loopback
+    mode = Hive::Web::AuthMode.resolve(
+      bind: "127.0.0.1",
+      config: { "auth" => "github", "github" => {} }
+    )
+    assert_equal "github", mode
+  end
+
+  def test_owner_claimed_forces_github_on_loopback
+    mode = Hive::Web::AuthMode.resolve(
+      bind: "127.0.0.1",
+      config: { "auth" => nil, "github" => { "owner" => "alice" } }
+    )
+    assert_equal "github", mode
+  end
+
+  def test_non_loopback_defaults_to_github
+    mode = Hive::Web::AuthMode.resolve(
+      bind: "0.0.0.0",
+      config: { "auth" => nil, "github" => {} }
+    )
+    assert_equal "github", mode
+  end
+
+  def test_non_loopback_unsafe_no_auth
+    mode = nil
+    _out, err = capture_io do
+      mode = Hive::Web::AuthMode.assert_safe!(
+        bind: "0.0.0.0",
+        config: { "auth" => nil, "github" => {} },
+        unsafe_no_auth: true
+      )
+    end
+    assert_equal "none", mode
+    assert_match(/WARNING/, err)
+  end
+
+  def test_assert_safe_allows_non_loopback_with_github
+    mode = Hive::Web::AuthMode.assert_safe!(
+      bind: "0.0.0.0",
+      config: { "auth" => nil, "github" => {} },
+      unsafe_no_auth: false
+    )
+    assert_equal "github", mode
+  end
+
+  def test_loopback_detection_covers_127_range
+    assert Hive::Web::AuthMode.loopback?("127.0.0.1")
+    assert Hive::Web::AuthMode.loopback?("127.1.2.3")
+    assert Hive::Web::AuthMode.loopback?("::1")
+    refute Hive::Web::AuthMode.loopback?("0.0.0.0")
+    refute Hive::Web::AuthMode.loopback?("192.168.1.1")
+  end
+end
diff --git a/test/unit/web/web_command_test.rb b/test/unit/web/web_command_test.rb
index 11de4ab0..2ce71f73 100644
--- a/test/unit/web/web_command_test.rb
+++ b/test/unit/web/web_command_test.rb
@@ -4,20 +4,22 @@ require "hive/commands/web"
 class WebCommandTest < Minitest::Test
   include HiveTestHelper
 
-  # `hive web` now boots the Rails app under web/; outside the container or
-  # a source checkout (no web/ dir, no HIVEBOX_WEB_APP_DIR) it must fail
-  # loudly with guidance instead of exec-ing into a missing app.
+  # `hive web` boots the Rails app under web/; when no env override, source
+  # sibling, or current-version provisioned copy exists it must fail loudly
+  # with setup guidance instead of exec-ing into a missing app.
   def test_missing_rails_app_exits_with_guidance
     with_tmp_global_config do
       with_env("HIVEBOX_WEB_APP_DIR" => File.join(Dir.mktmpdir("hive-noapp"), "nope")) do
-        command = Hive::Commands::Web.new
+        command = Hive::Commands::Web.new(nil)
         # Singleton override instead of minitest/mock (not bundled): the
         # checkout itself contains web/, so the fallback path would resolve.
         command.define_singleton_method(:rails_app_dir) { nil }
-        err = assert_raises(SystemExit) do
-          capture_io { command.call }
+        err = nil
+        _out, stderr = capture_io do
+          err = assert_raises(SystemExit) { command.call }
         end
         assert_equal 1, err.status, "a missing web app must exit 1"
+        assert_match(/hive setup|hive web install/, stderr)
       end
     end
   end
@@ -34,6 +36,84 @@ class WebCommandTest < Minitest::Test
     end
   end
 
+  def test_rails_app_dir_prefers_source_sibling_over_provisioned
+    Dir.mktmpdir("hive-data") do |data|
+      provisioned = File.join(data, "webapp", Hive::VERSION, "web")
+      FileUtils.mkdir_p(File.join(provisioned, "config"))
+      File.write(File.join(provisioned, "config", "application.rb"), "# provisioned\n")
+      File.write(File.join(provisioned, Hive::Web::AppProvisioner::MARKER), "v\n")
+      with_env("HIVEBOX_WEB_APP_DIR" => nil, "HIVE_HOME" => data) do
+        ENV.delete("HIVEBOX_WEB_APP_DIR")
+        command = Hive::Commands::Web.new
+        # Source checkout is present in this worktree — must win over provisioned.
+        source = File.expand_path("../../../web", File.expand_path("../../../lib/hive/commands", __dir__))
+        # web_command_test lives at test/unit/web → ../../../ is repo root
+        source = File.expand_path("../../../web", __dir__)
+        if File.file?(File.join(source, "config", "application.rb"))
+          assert_equal source, command.send(:rails_app_dir)
+        end
+      end
+    end
+  end
+
+  def test_rails_app_dir_uses_provisioned_when_no_source_or_env
+    Dir.mktmpdir("hive-data") do |data|
+      provisioned = File.join(data, "webapp", Hive::VERSION, "web")
+      FileUtils.mkdir_p(File.join(provisioned, "config"))
+      File.write(File.join(provisioned, "config", "application.rb"), "# provisioned\n")
+      File.write(File.join(provisioned, Hive::Web::AppProvisioner::MARKER), "v\n")
+
+      command = Hive::Commands::Web.new
+      # Force miss on env + source by stubbing the private resolution path.
+      command.define_singleton_method(:rails_app_dir) do
+        env_dir = ENV["HIVEBOX_WEB_APP_DIR"]
+        return env_dir if env_dir && File.file?(File.join(env_dir, "config", "application.rb"))
+
+        # Skip source sibling intentionally for this unit test.
+        return provisioned if Hive::Web::AppProvisioner.provisioned?(data_home: data, version: Hive::VERSION)
+
+        nil
+      end
+      with_env("HIVEBOX_WEB_APP_DIR" => nil) do
+        ENV.delete("HIVEBOX_WEB_APP_DIR")
+        assert_equal provisioned, command.send(:rails_app_dir)
+      end
+    end
+  end
+
+  def test_stale_provisioned_version_is_not_silently_used
+    Dir.mktmpdir("hive-data") do |data|
+      stale = File.join(data, "webapp", "0.0.1", "web")
+      FileUtils.mkdir_p(File.join(stale, "config"))
+      File.write(File.join(stale, "config", "application.rb"), "# stale\n")
+      File.write(File.join(stale, Hive::Web::AppProvisioner::MARKER), "v\n")
+
+      command = Hive::Commands::Web.new
+      # Simulate gem install: no env, no source sibling, only a stale version.
+      command.define_singleton_method(:rails_app_dir) do
+        return nil if ENV["HIVEBOX_WEB_APP_DIR"].to_s.empty? ||
+                      !File.file?(File.join(ENV["HIVEBOX_WEB_APP_DIR"], "config", "application.rb"))
+
+        ENV["HIVEBOX_WEB_APP_DIR"]
+      end
+      # Directly exercise the stale helper via a real instance under HIVE_HOME.
+      with_env("HIVE_HOME" => data) do
+        real = Hive::Commands::Web.new
+        real.define_singleton_method(:rails_app_dir) do
+          # no env
+          # no source
+          provisioned = Hive::Web::AppProvisioner.provisioned_app_dir
+          return provisioned if Hive::Web::AppProvisioner.provisioned?
+
+          nil
+        end
+        assert_nil real.send(:rails_app_dir),
+                   "a provisioned dir for a different hive version must not be used"
+        assert_equal "0.0.1", real.send(:stale_provisioned_version)
+      end
+    end
+  end
+
   def test_public_bind_without_https_origin_warns
     with_tmp_global_config do
       command = Hive::Commands::Web.new
@@ -83,7 +163,7 @@ class WebCommandTest < Minitest::Test
     with_tmp_global_config do
       with_stub_rails_app(prepare_exit: 1) do
         error = assert_raises(Hive::Error) do
-          capture_io { Hive::Commands::Web.new.call }
+          capture_io { Hive::Commands::Web.new(nil).call }
         end
         assert_match(/db:prepare failed/, error.message)
         assert_match(/writable/, error.message, "the message must point at the /data mount")
@@ -101,7 +181,7 @@ class WebCommandTest < Minitest::Test
 
         caught = nil
         begin
-          capture_io { Hive::Commands::Web.new.call }
+          capture_io { Hive::Commands::Web.new(nil).call }
         rescue ExecCaught => e
           caught = e
         ensure
@@ -112,6 +192,31 @@ class WebCommandTest < Minitest::Test
         assert_equal %w[bin/rails server -b], caught.argv[0..2]
         assert caught.env.key?("SECRET_KEY_BASE"), "the persisted session secret must reach Rails"
         assert caught.env.key?("HIVEBOX_STORAGE_DIR")
+        assert_equal "none", caught.env["HIVEBOX_AUTH_MODE"],
+                     "default loopback bind must export auth mode none"
+      end
+    end
+  end
+
+  def test_non_loopback_without_unsafe_uses_github_auth
+    with_tmp_global_config do
+      with_stub_rails_app(prepare_exit: 0) do
+        original = Kernel.method(:exec)
+        Kernel.define_singleton_method(:exec) do |env, *argv|
+          raise ExecCaught.new(env, argv)
+        end
+
+        caught = nil
+        begin
+          capture_io { Hive::Commands::Web.new(nil, bind: "0.0.0.0").call }
+        rescue ExecCaught => e
+          caught = e
+        ensure
+          Kernel.define_singleton_method(:exec, original)
+        end
+
+        refute_nil caught
+        assert_equal "github", caught.env["HIVEBOX_AUTH_MODE"]
       end
     end
   end
diff --git a/web/Gemfile b/web/Gemfile
index 53710d90..3f360259 100644
--- a/web/Gemfile
+++ b/web/Gemfile
@@ -70,4 +70,21 @@ end
 # The hive control plane: status payloads, gate approval, daemon dispatch,
 # the GitHub device-flow gate, the agent OAuth relay, and Telegram
 # validation all come from the gem — the web tier adds no pipeline logic.
-gem "hive-cli", path: ".."
+#
+# In a source checkout (and the Docker image, which layout-matches it)
+# resolve via path: ".." so local edits are picked up without a gem install.
+# In a provisioned XDG runtime copy (`…/webapp/<version>/web`) there is no
+# sibling gemspec — pin the installed hive-cli gem to that version instead.
+hive_gemspec = File.expand_path("../hive.gemspec", __dir__)
+if File.exist?(hive_gemspec)
+  gem "hive-cli", path: ".."
+else
+  # Parent dir is webapp/<Hive::VERSION> under the provisioned layout; fall
+  # back to an unpinned installed gem if the path doesn't look like a version.
+  provisioned_version = File.basename(File.expand_path("..", __dir__))
+  if provisioned_version.match?(/\A\d+\.\d+/)
+    gem "hive-cli", provisioned_version
+  else
+    gem "hive-cli"
+  end
+end
diff --git a/web/app/controllers/application_controller.rb b/web/app/controllers/application_controller.rb
index 2a1e5e28..2e60ad38 100644
--- a/web/app/controllers/application_controller.rb
+++ b/web/app/controllers/application_controller.rb
@@ -10,8 +10,9 @@ class ApplicationController < ActionController::Base
   stale_when_importmap_changes
 
   before_action :require_login
+  before_action :enforce_local_host, if: :auth_none?
 
-  helper_method :current_login
+  helper_method :current_login, :auth_none?, :local_mode?
 
   # Hive's typed errors are operator-readable by design ("task not in stage",
   # "invalid clone URL"). Render them on an error page instead of a blank
@@ -45,11 +46,27 @@ class ApplicationController < ActionController::Base
     end
   end
 
+  # Effective auth mode is resolved by the CLI (`hive web`) and exported as
+  # HIVEBOX_AUTH_MODE. Default to "github" when unset so direct `bin/rails
+  # server` boots and Docker (which historically always required login)
+  # stay fail-closed.
+  def auth_mode
+    ENV.fetch("HIVEBOX_AUTH_MODE", "github").to_s
+  end
+
+  def auth_none?
+    auth_mode == "none"
+  end
+  alias local_mode? auth_none?
+
   def current_login
+    return "local" if auth_none?
+
     session[:github_login]
   end
 
   def require_login
+    return if auth_none?
     return redirect_to login_path unless current_login
 
     # Sessions must track the CURRENT owner, not the owner at sign-in time:
@@ -65,6 +82,30 @@ class ApplicationController < ActionController::Base
     redirect_to login_path, alert: "Signed out: this box's owner changed."
   end
 
+  # DNS-rebinding guard for no-auth mode: only accept Host headers that
+  # match loopback or the configured origin host.
+  def enforce_local_host
+    host = request.host.to_s.downcase
+    return if loopback_host?(host)
+    return if origin_host?(host)
+
+    head :forbidden
+  end
+
+  def loopback_host?(host)
+    host == "localhost" || host == "::1" || host.match?(/\A127(?:\.\d{1,3}){3}\z/)
+  end
+
+  def origin_host?(host)
+    origin = ENV.fetch("HIVEBOX_ORIGIN", "").to_s
+    return false if origin.empty?
+
+    uri = URI.parse(origin)
+    uri.host.to_s.downcase == host
+  rescue URI::InvalidURIError
+    false
+  end
+
   def registered_projects
     @registered_projects ||= Hive::Config.registered_projects
   end
diff --git a/web/app/controllers/daemon_controller.rb b/web/app/controllers/daemon_controller.rb
new file mode 100644
index 00000000..e182f09b
--- /dev/null
+++ b/web/app/controllers/daemon_controller.rb
@@ -0,0 +1,58 @@
+# frozen_string_literal: true
+
+require "open3"
+require "timeout"
+
+# Web-driven daemon start/repair. Spawns fixed argv arrays (no user input)
+# because the dispatch-request queue can't be used: its consumer is the
+# daemon being repaired.
+class DaemonController < ApplicationController
+  REPAIR_TIMEOUT_SEC = 30
+
+  before_action :require_owner_for_repair!
+
+  def start
+    result = spawn_hive(%w[daemon start --detach])
+    redirect_back fallback_location: root_path,
+                  notice: result[:ok] ? "Daemon start requested." : "Daemon start failed: #{result[:detail]}"
+  end
+
+  def repair
+    result = spawn_hive(%w[daemon install --force])
+    if result[:ok]
+      start_result = spawn_hive(%w[daemon start --detach])
+      msg = "Daemon unit repaired."
+      msg += " Start: #{start_result[:detail]}" unless start_result[:ok]
+      redirect_back fallback_location: root_path, notice: msg
+    else
+      redirect_back fallback_location: root_path,
+                    alert: "Daemon repair failed: #{result[:detail]}"
+    end
+  end
+
+  private
+
+  def require_owner_for_repair!
+    return if auth_none?
+
+    login = session[:github_login]
+    auth = Hive::Web::GithubAuth.new(config: Hive::Config.load_global_web)
+    return if login && auth.owner?(login)
+    return if Rails.env.local? && login.present?
+
+    head :forbidden
+  end
+
+  def spawn_hive(args)
+    bin = Hive::InvokedBinary.path || "hive"
+    argv = [ bin ] + args
+    out, status = Timeout.timeout(REPAIR_TIMEOUT_SEC) do
+      Open3.capture2e(*argv)
+    end
+    { ok: status.success?, detail: out.to_s.strip.presence || (status.success? ? "ok" : "exit #{status.exitstatus}") }
+  rescue Timeout::Error
+    { ok: false, detail: "timed out after #{REPAIR_TIMEOUT_SEC}s" }
+  rescue Errno::ENOENT => e
+    { ok: false, detail: e.message }
+  end
+end
diff --git a/web/app/controllers/health_controller.rb b/web/app/controllers/health_controller.rb
index cda67e40..7a498bb1 100644
--- a/web/app/controllers/health_controller.rb
+++ b/web/app/controllers/health_controller.rb
@@ -1,7 +1,10 @@
 require "hive/pid_file"
+require "open3"
+require "timeout"
 
 class HealthController < ApplicationController
   skip_before_action :require_login
+  skip_before_action :enforce_local_host, raise: false
 
   # Reads the daemon's pidfile the same way `hive daemon status` does —
   # stale files and reused PIDs don't count as alive.
@@ -21,11 +24,50 @@ class HealthController < ApplicationController
   def show
     return render json: { ok: true } unless params[:deep].present?
 
-    daemon_pid = DaemonProbe.new.read_live_pid
-    if daemon_pid
-      render json: { ok: true, daemon: { running: true, pid: daemon_pid } }
+    daemon = daemon_health_payload
+    if daemon[:running]
+      render json: { ok: true, daemon: daemon }
     else
-      render json: { ok: false, daemon: { running: false } }, status: :service_unavailable
+      render json: { ok: false, daemon: daemon }, status: :service_unavailable
+    end
+  end
+
+  private
+
+  def daemon_health_payload
+    daemon_pid = DaemonProbe.new.read_live_pid
+    payload = {
+      running: !daemon_pid.nil?,
+      pid: daemon_pid,
+      version: nil,
+      binary_path: nil,
+      cli_version: Hive::VERSION,
+      drifted: false
+    }
+
+    begin
+      require "hive/commands/daemon/service_installer"
+      installer = Hive::Commands::Daemon::ServiceInstaller.new
+      unit_bin = installer.installed_binary_path
+      payload[:binary_path] = unit_bin
+      if unit_bin && File.executable?(unit_bin)
+        out, status = Timeout.timeout(5) { Open3.capture2(unit_bin, "version") }
+        if status.success?
+          ver = out.to_s[/\d+\.\d+\.\d+/]
+          payload[:version] = ver
+          payload[:drifted] = ver && ver != Hive::VERSION
+        end
+      end
+      cli = Hive::InvokedBinary.path
+      if unit_bin && cli
+        unit_real = File.exist?(unit_bin) ? File.realpath(unit_bin) : unit_bin
+        cli_real = File.exist?(cli) ? File.realpath(cli) : cli
+        payload[:drifted] ||= unit_real != cli_real
+      end
+    rescue StandardError
+      # Deep health must still report running/pid even if drift probe fails.
     end
+
+    payload
   end
 end
diff --git a/web/app/controllers/sessions_controller.rb b/web/app/controllers/sessions_controller.rb
index f1fecfd8..1ce7c38b 100644
--- a/web/app/controllers/sessions_controller.rb
+++ b/web/app/controllers/sessions_controller.rb
@@ -14,6 +14,8 @@ class SessionsController < ApplicationController
   class_attribute :http_client, default: Net::HTTP
 
   def new
+    # Local no-auth mode has no GitHub login page — bounce to the grid.
+    return redirect_to root_path if auth_none?
     return redirect_to root_path if current_login
 
     # Surface a misconfigured box on the page itself — a sign-in button that
diff --git a/web/app/controllers/status_controller.rb b/web/app/controllers/status_controller.rb
index c44440a8..e67d6abe 100644
--- a/web/app/controllers/status_controller.rb
+++ b/web/app/controllers/status_controller.rb
@@ -1,6 +1,45 @@
+require "hive/pid_file"
+
 class StatusController < ApplicationController
+  class DaemonProbe
+    include Hive::PidFile
+
+    def pid_file
+      File.join(Hive::Paths.state_home, ".daemon.pid")
+    end
+  end
+
   def index
     @payload = StatusBroadcaster.snapshot
     @projects = @payload.fetch("projects", [])
+    @daemon_health = probe_daemon_health
+  end
+
+  private
+
+  def probe_daemon_health
+    pid = DaemonProbe.new.read_live_pid
+    health = {
+      running: !pid.nil?,
+      pid: pid,
+      drifted: false,
+      unit_binary: nil,
+      cli_binary: Hive::InvokedBinary.path,
+      cli_version: Hive::VERSION
+    }
+    begin
+      require "hive/commands/daemon/service_installer"
+      installer = Hive::Commands::Daemon::ServiceInstaller.new
+      unit_bin = installer.installed_binary_path
+      health[:unit_binary] = unit_bin
+      if unit_bin && health[:cli_binary]
+        unit_real = File.exist?(unit_bin) ? File.realpath(unit_bin) : unit_bin
+        cli_real = File.exist?(health[:cli_binary]) ? File.realpath(health[:cli_binary]) : health[:cli_binary]
+        health[:drifted] = unit_real != cli_real
+      end
+    rescue StandardError
+      nil
+    end
+    health
   end
 end
diff --git a/web/app/views/layouts/application.html.erb b/web/app/views/layouts/application.html.erb
index 77e0c5f9..48ff3119 100644
--- a/web/app/views/layouts/application.html.erb
+++ b/web/app/views/layouts/application.html.erb
@@ -32,8 +32,12 @@
             <%= link_to "Telegram", telegram_path, class: nav_class(:telegram) %>
           </nav>
           <div class="topbar-session">
-            <span class="session-login"><%= current_login %></span>
-            <%= button_to "Log out", logout_path, class: "btn btn-ghost btn-sm", form_class: "inline-form" %>
+            <% if local_mode? %>
+              <span class="session-login" title="Local mode — GitHub auth off">local</span>
+            <% else %>
+              <span class="session-login"><%= current_login %></span>
+              <%= button_to "Log out", logout_path, class: "btn btn-ghost btn-sm", form_class: "inline-form" %>
+            <% end %>
           </div>
         <% end %>
       </div>
diff --git a/web/app/views/status/_daemon_banner.html.erb b/web/app/views/status/_daemon_banner.html.erb
new file mode 100644
index 00000000..4c98dbf3
--- /dev/null
+++ b/web/app/views/status/_daemon_banner.html.erb
@@ -0,0 +1,28 @@
+<% if daemon_health && (!daemon_health[:running] || daemon_health[:drifted]) %>
+  <div class="state-banner" role="status" data-testid="daemon-health-banner">
+    <div class="daemon-banner-body">
+      <% if !daemon_health[:running] %>
+        <strong>Daemon is not running.</strong>
+        Tasks will not auto-advance until it is started.
+        <code class="muted">hive daemon start</code>
+      <% elsif daemon_health[:drifted] %>
+        <strong>Daemon binary drift detected.</strong>
+        Unit: <code><%= daemon_health[:unit_binary] %></code>
+        CLI: <code><%= daemon_health[:cli_binary] %></code> (v<%= daemon_health[:cli_version] %>)
+        <code class="muted">hive daemon install --force</code>
+      <% end %>
+    </div>
+    <div class="daemon-banner-actions">
+      <% if !daemon_health[:running] %>
+        <%= button_to "Start daemon", daemon_start_path, method: :post,
+              class: "btn btn-sm",
+              form: { data: { turbo: true } } %>
+      <% end %>
+      <% if daemon_health[:drifted] %>
+        <%= button_to "Repair unit", daemon_repair_path, method: :post,
+              class: "btn btn-sm",
+              form: { data: { turbo: true } } %>
+      <% end %>
+    </div>
+  </div>
+<% end %>
diff --git a/web/app/views/status/index.html.erb b/web/app/views/status/index.html.erb
index 25bcdf79..6fa2ed41 100644
--- a/web/app/views/status/index.html.erb
+++ b/web/app/views/status/index.html.erb
@@ -9,6 +9,8 @@
 <% end %>
 <%= turbo_stream_from StatusBroadcaster::CHANNEL %>
 
+<%= render "status/daemon_banner", daemon_health: @daemon_health %>
+
 <%# TUI left-pane parity: the rail filters the grid client-side (buttons,
     not links — a navigation would discard the permanent composer's typed
     text). The controller wraps rail AND grid; it re-applies the filter
diff --git a/web/config/routes.rb b/web/config/routes.rb
index 659576df..2e1714d9 100644
--- a/web/config/routes.rb
+++ b/web/config/routes.rb
@@ -19,6 +19,10 @@ Rails.application.routes.draw do
 
   post "ideas" => "ideas#create", as: :ideas
 
+  # Daemon repair from the web UI (fixed argv; not via dispatch queue).
+  post "daemon/start" => "daemon#start", as: :daemon_start
+  post "daemon/repair" => "daemon#repair", as: :daemon_repair
+
   # Task pages are addressed by project name + task slug, mirroring the CLI.
   scope "tasks/:project/:slug", constraints: { slug: /[a-z][a-z0-9-]{0,62}[a-z0-9]/, project: %r{[^/]+} } do
     get  "" => "tasks#show", as: :task
